# SdFat: ExFatVolume Class Reference

ExFatVolume Class Reference

exFAT volume. More...

`#include <ExFatVolume.h>`

Inheritance diagram for ExFatVolume:
[legend]
Collaboration diagram for ExFatVolume:
[legend]

## Public Member Functions

bool | begin (BlockDevice *dev, bool setCwv=true, uint8_t part=1)
uint32_t | bytesPerCluster ()
uint8_t | bytesPerClusterShift ()
uint16_t | bytesPerSector ()
uint8_t | bytesPerSectorShift ()
uint8_t * | cacheClear ()
bool | chdir ()
bool | chdir (const ExChar_t *path)
bool | chdir (const String &path)
void | chvol ()
uint32_t | clusterCount ()
uint32_t | clusterHeapStartSector ()
bool | exists (const ExChar_t *path)
bool | exists (const String &path)
uint32_t | fatLength ()
uint32_t | fatStartSector ()
uint8_t | fatType () const
uint32_t | freeClusterCount ()
bool | init (BlockDevice *dev, uint8_t part)
bool | ls ()
bool | ls (const ExChar_t *path, uint8_t flags=0)
bool | ls (print_t *pr, const ExChar_t *path, uint8_t flags)
bool | ls (print_t *pr, uint8_t flags=0)
bool | ls (uint8_t flags)
bool | mkdir (const ExChar_t *path, bool pFlag=true)
bool | mkdir (const String &path, bool pFlag=true)
ExFile | open (const ExChar_t *path, oflag_t oflag=0X00)
ExFile | open (const String &path, oflag_t oflag=0X00)
bool | remove (const ExChar_t *path)
bool | remove (const String &path)
bool | rename (const ExChar_t *oldPath, const ExChar_t *newPath)
bool | rename (const String &oldPath, const String &newPath)
bool | rmdir (const ExChar_t *path)
bool | rmdir (const String &path)
uint32_t | rootDirectoryCluster ()
uint32_t | rootLength ()
uint32_t | sectorsPerCluster ()
uint8_t | sectorsPerClusterShift ()
bool | truncate (const ExChar_t *path, uint64_t length)
bool | truncate (const String &path, uint64_t length)

## Static Public Member Functions

static ExFatVolume * | cwv ()

## Detailed Description

exFAT volume.

Copyright (c) 2011-2019 Bill Greiman This file is part of the SdFat library for SD memory cards.

MIT License

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

## Member Function Documentation

## begin()

bool ExFatVolume::begin | ( | BlockDevice * | dev,
|  | bool | setCwv = `true`,
|  | uint8_t | part = `1`
| ) |  |

inline

Initialize an FatVolume object.

Parameters

  [in] | dev | Device block driver.
  [in] | setCwv | Set current working volume if true.
  [in] | part | partition to initialize.

Returns
  true for success or false for failure.

## bytesPerCluster()

uint32_t ExFatPartition::bytesPerCluster | ( |  | ) |

inlineinherited

Returns
  the number of bytes in a cluster.

## bytesPerClusterShift()

uint8_t ExFatPartition::bytesPerClusterShift | ( |  | ) |

inlineinherited

Returns
  the power of two for bytesPerCluster.

## bytesPerSector()

uint16_t ExFatPartition::bytesPerSector | ( |  | ) |

inlineinherited

Returns
  the number of bytes in a sector.

## bytesPerSectorShift()

uint8_t ExFatPartition::bytesPerSectorShift | ( |  | ) |

inlineinherited

Returns
  the power of two for bytesPerSector.

## cacheClear()

uint8_t* ExFatPartition::cacheClear | ( |  | ) |

inlineinherited

Clear the cache and returns a pointer to the cache. Not for normal apps.

Returns
  A pointer to the cache buffer or zero if an error occurs.

## chdir() [1/3]

bool ExFatVolume::chdir | ( |  | ) |

inline

Set volume working directory to root.

Returns
  true for success or false for failure.

## chdir() [2/3]

bool ExFatVolume::chdir | ( | const ExChar_t * | path | ) |

Set volume working directory.

Parameters

  [in] | path | Path for volume working directory.

Returns
  true for success or false for failure.

## chdir() [3/3]

bool ExFatVolume::chdir | ( | const String & | path | ) |

inline

Set volume working directory.

Parameters

  [in] | path | Path for volume working directory.

Returns
  true for success or false for failure.

## chvol()

void ExFatVolume::chvol | ( |  | ) |

inline

Change global working volume to this volume.

## clusterCount()

uint32_t ExFatPartition::clusterCount | ( |  | ) |

inlineinherited

Returns
  the cluster count for the partition.

## clusterHeapStartSector()

uint32_t ExFatPartition::clusterHeapStartSector | ( |  | ) |

inlineinherited

Returns
  the cluster heap start sector.

## cwv()

static ExFatVolume* ExFatVolume::cwv | ( |  | ) |

inlinestatic

Returns
  current working volume.

## exists() [1/2]

bool ExFatVolume::exists | ( | const ExChar_t * | path | ) |

inline

Test for the existence of a file.

Parameters

  [in] | path | Path of the file to be tested for.

Returns
  true if the file exists else false.

## exists() [2/2]

bool ExFatVolume::exists | ( | const String & | path | ) |

inline

Test for the existence of a file in a directory

Parameters

  [in] | path | Path of the file to be tested for.

Returns
  true if the file exists else false.

## fatLength()

uint32_t ExFatPartition::fatLength | ( |  | ) |

inlineinherited

Returns
  the FAT length in sectors

## fatStartSector()

uint32_t ExFatPartition::fatStartSector | ( |  | ) |

inlineinherited

Returns
  the FAT start sector number.

## fatType()

uint8_t ExFatPartition::fatType | ( |  | ) | const

inlineinherited

Returns
  Type FAT_TYPE_EXFAT for exFAT partition or zero for error.

## freeClusterCount()

uint32_t ExFatPartition::freeClusterCount | ( |  | ) |

inherited

Returns
  the free cluster count.

## init()

bool ExFatPartition::init | ( | BlockDevice * | dev,
|  | uint8_t | part
| ) |  |

inherited

Initialize a exFAT partition.

Parameters

  [in] | dev | The blockDevice for the partition.
  [in] | part | The partition to be used. Legal values for part are 1-4 to use the corresponding partition on a device formatted with a MBR, Master Boot Record, or zero if the device is formatted as a super floppy with the FAT boot sector in sector zero.

Returns
  true for success or false for failure.

## ls() [1/5]

bool ExFatVolume::ls | ( |  | ) |

inline

List the directory contents of the root directory to Serial.

Returns
  true for success or false for failure.

## ls() [2/5]

bool ExFatVolume::ls | ( | const ExChar_t * | path,
|  | uint8_t | flags = `0`
| ) |  |

inline

List the directory contents of a directory to Serial.

Parameters

  [in] | path | directory to list.
  [in] | flags | The inclusive OR of

LS_DATE - Print file modification date

LS_SIZE - Print file size.

LS_R - Recursive list of subdirectories.

Returns
  true for success or false for failure.

## ls() [3/5]

bool ExFatVolume::ls | ( | print_t * | pr,
|  | const ExChar_t * | path,
|  | uint8_t | flags
| ) |  |

inline

List the contents of a directory.

Parameters

  [in] | pr | Print stream for list.
  [in] | path | directory to list.
  [in] | flags | The inclusive OR of

LS_DATE - Print file modification date

LS_SIZE - Print file size.

LS_R - Recursive list of subdirectories.

Returns
  true for success or false for failure.

## ls() [4/5]

bool ExFatVolume::ls | ( | print_t * | pr,
|  | uint8_t | flags = `0`
| ) |  |

inline

List the directory contents of the root directory.

Parameters

  [in] | pr | Print stream for list.
  [in] | flags | The inclusive OR of

LS_DATE - Print file modification date

LS_SIZE - Print file size.

LS_R - Recursive list of subdirectories.

Returns
  true for success or false for failure.

## ls() [5/5]

bool ExFatVolume::ls | ( | uint8_t | flags | ) |

inline

List the directory contents of the volume root to Serial.

Parameters

  [in] | flags | The inclusive OR of

LS_DATE - Print file modification date

LS_SIZE - Print file size.

LS_R - Recursive list of subdirectories.

Returns
  true for success or false for failure.

## mkdir() [1/2]

bool ExFatVolume::mkdir | ( | const ExChar_t * | path,
|  | bool | pFlag = `true`
| ) |  |

inline

Make a subdirectory in the volume root directory.

Parameters

  [in] | path | A path with a valid 8.3 DOS name for the subdirectory.
  [in] | pFlag | Create missing parent directories if true.

Returns
  true for success or false for failure.

## mkdir() [2/2]

bool ExFatVolume::mkdir | ( | const String & | path,
|  | bool | pFlag = `true`
| ) |  |

inline

Make a subdirectory in the volume root directory.

Parameters

  [in] | path | A path with a valid 8.3 DOS name for the subdirectory.
  [in] | pFlag | Create missing parent directories if true.

Returns
  true for success or false for failure.

## open() [1/2]

ExFile ExFatVolume::open | ( | const ExChar_t * | path,
|  | oflag_t | oflag = `0X00`
| ) |  |

inline

open a file

Parameters

  [in] | path | location of file to be opened.
  [in] | oflag | open flags.

Returns
  a ExFile object.

## open() [2/2]

ExFile ExFatVolume::open | ( | const String & | path,
|  | oflag_t | oflag = `0X00`
| ) |  |

inline

open a file

Parameters

  [in] | path | location of file to be opened.
  [in] | oflag | open oflag flags.

Returns
  a ExFile object.

## remove() [1/2]

bool ExFatVolume::remove | ( | const ExChar_t * | path | ) |

inline

Remove a file from the volume root directory.

Parameters

  [in] | path | A path with a valid 8.3 DOS name for the file.

Returns
  true for success or false for failure.

## remove() [2/2]

bool ExFatVolume::remove | ( | const String & | path | ) |

inline

Remove a file from the volume root directory.

Parameters

  [in] | path | A path with a valid name for the file.

Returns
  true for success or false for failure.

## rename() [1/2]

bool ExFatVolume::rename | ( | const ExChar_t * | oldPath,
|  | const ExChar_t * | newPath
| ) |  |

inline

Rename a file or subdirectory.

Parameters

  [in] | oldPath | Path name to the file or subdirectory to be renamed.
  [in] | newPath | New path name of the file or subdirectory.

The newPath object must not exist before the rename call.

The file to be renamed must not be open. The directory entry may be moved and file system corruption could occur if the file is accessed by a file object that was opened before the rename() call.

Returns
  true for success or false for failure.

## rename() [2/2]

bool ExFatVolume::rename | ( | const String & | oldPath,
|  | const String & | newPath
| ) |  |

inline

Rename a file or subdirectory.

Parameters

  [in] | oldPath | Path name to the file or subdirectory to be renamed.
  [in] | newPath | New path name of the file or subdirectory.

The newPath object must not exist before the rename call.

The file to be renamed must not be open. The directory entry may be moved and file system corruption could occur if the file is accessed by a file object that was opened before the rename() call.

Returns
  true for success or false for failure.

## rmdir() [1/2]

bool ExFatVolume::rmdir | ( | const ExChar_t * | path | ) |

inline

Remove a subdirectory from the volume's working directory.

Parameters

  [in] | path | A path with a valid 8.3 DOS name for the subdirectory.

The subdirectory file will be removed only if it is empty.

Returns
  true for success or false for failure.

## rmdir() [2/2]

bool ExFatVolume::rmdir | ( | const String & | path | ) |

inline

Remove a subdirectory from the volume's working directory.

Parameters

  [in] | path | A path with a valid name for the subdirectory.

The subdirectory file will be removed only if it is empty.

Returns
  true for success or false for failure.

## rootDirectoryCluster()

uint32_t ExFatPartition::rootDirectoryCluster | ( |  | ) |

inlineinherited

Returns
  the root directory start cluster number.

## rootLength()

uint32_t ExFatPartition::rootLength | ( |  | ) |

inherited

Returns
  the root directory length.

## sectorsPerCluster()

uint32_t ExFatPartition::sectorsPerCluster | ( |  | ) |

inlineinherited

Returns
  the number of sectors in a cluster.

## sectorsPerClusterShift()

uint8_t ExFatPartition::sectorsPerClusterShift | ( |  | ) |

inlineinherited

Returns
  the power of two for sectors per cluster.

## truncate() [1/2]

bool ExFatVolume::truncate | ( | const ExChar_t * | path,
|  | uint64_t | length
| ) |  |

inline

Truncate a file to a specified length. The current file position will be at the new EOF.

Parameters

  [in] | path | A path with a valid 8.3 DOS name for the file.
  [in] | length | The desired length for the file.

Returns
  true for success or false for failure.

## truncate() [2/2]

bool ExFatVolume::truncate | ( | const String & | path,
|  | uint64_t | length
| ) |  |

inline

Truncate a file to a specified length. The current file position will be at the new EOF.

Parameters

  [in] | path | A path with a valid name for the file.
  [in] | length | The desired length for the file.

Returns
  true for success or false for failure.

The documentation for this class was generated from the following files:

- ArduinoSdFat/libraries/SdFat/src/ExFatLib/ExFatVolume.h
- ArduinoSdFat/libraries/SdFat/src/ExFatLib/ExFatVolume.cpp